/*
 * PDAC.h
 */

#ifndef PDAC_H_
#define PDAC_H_

#include <stdio.h> //4 NULL
#include <list> //4 LIST

class PDAC_rule;

class PDAC_dev
{
public:
    const char* id;
    const char* description;

    bool enabled;

    const char *owner;
    const char *group;

    const char* mode;
    const char* maclabel;
    const char* audit;

    const char** attributes;

    const char** rules;

    PDAC_dev(): id(NULL), description(NULL), enabled(false),
        owner(NULL), group(NULL), mode(NULL), maclabel(NULL), audit(NULL),
        attributes(NULL), rules(NULL) {}

    bool isValid();
};

class PDAC_rule
{

public:
    const char* id;
    const char* description;

    bool enabled;

    const char** attributes;

    PDAC_rule():    id(NULL), description(NULL), enabled(false),
        attributes(NULL) {}

    bool is_valid();
};

bool PDAC_load(std::list<PDAC_dev*> *devices, std::list<PDAC_rule*> *rules);

bool PDAC_save(const std::list<PDAC_dev*> *devices, const std::list<PDAC_rule*> *rules);
bool PDAC_ALD_gen_rules(const std::list<PDAC_dev*> *devices, const std::list<PDAC_rule*> *rules);

#endif /* PDAC_H_ */
